﻿
using System;
using System.Configuration;
using System.Collections.Generic;
using System.Collections;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using BitFactory.Logging;
using ClusterMaxDAL;
using System.Management.Automation;
using System.Management.Automation.Runspaces;
using System.IO;
using System.Xml;

using System.Net;

namespace CloudResourceManager
{
    
    public class XmlManager
    {
        static String strConfigFileName = "mytest.xml";
        XmlTextReader myReader;
        public Dictionary<String, String> hashTable = null;
       
        public void GetConfigParamOld()
        {
            myReader = new XmlTextReader(strConfigFileName);
            if (hashTable == null)
            {
                hashTable = new Dictionary<String, String>();
            }
            else
            {
                hashTable.Clear();
            }
            String keyName = "", keyValue = "";
            while (myReader.Read())
            {                
                bool bHasError = false;
                if  (myReader.NodeType == XmlNodeType.Element)
                {
                    bHasError = true;
                    Console.WriteLine("name=" + myReader.Name);
                    keyName = myReader.Name;
                    if (myReader.Read())
                    {
                        if (myReader.NodeType == XmlNodeType.Text)
                        {
                            Console.WriteLine("value=" + myReader.Value);
                            keyValue = myReader.Value;
                            if (myReader.Read())
                            {
                                if (myReader.NodeType == XmlNodeType.EndElement)
                                {
                                    hashTable.Add(keyName, keyValue);
                                    bHasError = false;
                                }
                            }
                        }
                    }                                    
                }
                if (bHasError)
                {
                    // TO DO: we need some kind of protection against corrupted xml format.
                    // ...
                    break;
                }
               
            }
            myReader.Close();

        }

        public void GetConfigParam()
        {
            try
            {
                myReader = new XmlTextReader(strConfigFileName);
                if (hashTable == null)
                {
                    hashTable = new Dictionary<String, String>();
                }
                else
                {
                    hashTable.Clear();
                }
                String keyName = "", keyValue = "";
                while (myReader.Read())
                {                    
                    switch (myReader.NodeType)
                    {
                        case XmlNodeType.Element:
                            keyName = myReader.Name;
                            break;
                        case XmlNodeType.Text:
                            keyValue = myReader.Value;
                            break;
                        case XmlNodeType.EndElement:
                            hashTable.Add(keyName, keyValue);
                            break;
                    }
                }
                myReader.Close();
            }
            catch (Exception e)
            {
                // Let the user know what went wrong.
                Console.WriteLine("The file could not be read:");
                Console.WriteLine(e.Message);
            }

        }

    }
}



